<?php

/**
 * BuddyServ IRC Services
 * 
 * RRD Graph generation and updating API
 * 
 * @name RRD
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Core
 * @version $Id: Class.rrd.php 325 2009-11-18 06:54:42Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */
 
class rrd
{
	public static $rrdfile;
	public static $rrdpng;
	public static $title;
	public static $vertical;
	
	public static function update($values)
	{
		global $me;
		
		if (!is_array($values))
			return false;
			
		$update_string = 'N';
		
		foreach ($values as $each => $one)
			$update_string .= ':'.$one;
			
		if (!self::$rrdfile)
			self::$rrdfile = $me->rrd_file;
			
		exec('rrdtool update '.self::$rrdfile.' '.$update_string);
		return true;
	}
	
	public static function graphLines($file=false, $timeframe=false)
	{
		global $me;
		
		if (!$file and !self::$rrdpng)
			self::$rrdpng = $me->rrd_pnglocation;
			
		elseif ($file)
			self::$rrdpng = $file;

		if (!self::$rrdfile)
			self::$rrdfile = $me->rrd_file;
			
		if ($timeframe >= 0)
			$timeframe = '-604800'; // default to 1 week
			 
			$graph_duration_title = duration_long($timeframe,0);
			
		$query = '/usr/bin/rrdtool graph '.self::$rrdpng.' '.
'--imgformat=PNG '.
'--start='.$timeframe.' '.
'--end=-300 '.
'--title="'.self::$title.' ['.$graph_duration_title."] (".strftime("%c", time()).')" '.
'--base=1000 '.
'--height=120 '.
'--width=600 '.
'--alt-autoscale '.
'--vertical-label="'.self::$vertical.'" '.
'--slope-mode '.
'--font TITLE:12: '.
'--font AXIS:8: '.
'--font LEGEND:10: '.
'--font UNIT:8: '.
'--color BACK#0F3A6A50 '.
'--color CANVAS#CAFFFD '.
'--color FONT#A5A6A7 '.
'--rigid '.
'DEF:a="'.self::$rrdfile.'":inLines:AVERAGE '.
'DEF:b="'.self::$rrdfile.'":inLines:MAX '.
'DEF:c="'.self::$rrdfile.'":outLines:AVERAGE '.
'DEF:d="'.self::$rrdfile.'":outLines:MAX '.
'DEF:e="'.self::$rrdfile.'":outLines:LAST '.
'DEF:f="'.self::$rrdfile.'":inLines:LAST '.
'DEF:g="'.self::$rrdfile.'":allLines:AVERAGE '.
'DEF:h="'.self::$rrdfile.'":allLines:MAX '.
'DEF:i="'.self::$rrdfile.'":allLines:LAST '.
'AREA:g#070531:"All Lines" '.
'TEXTALIGN:right '.
'GPRINT:g:LAST:"          Current\:%8.0lf" '.
'GPRINT:g:AVERAGE:"Average\:%8.0lf" '.
'GPRINT:g:MAX:"Max\:%8.0lf \n" '.
'AREA:a#0000FF:"Received"  '.
'TEXTALIGN:right '.
'GPRINT:a:LAST:"         Current\:%8.0lf"  '.
'GPRINT:a:AVERAGE:"Average\:%8.0lf"  '.
'GPRINT:a:MAX:"Max\:%8.0lf\n"  '.
'LINE2:c#16F32690:"Transmitted"  '.
'TEXTALIGN:right '.
'GPRINT:c:LAST:"    Current\:%8.0lf"  '.
'GPRINT:c:AVERAGE:"Average\:%8.0lf" '.
'GPRINT:c:MAX:"Max\:%8.0lf\n"';
		
		
		exec($query);
	}
	
	public static function graph($file=false, $timeframe=false)
	{
		global $me;
		
		if (!$file and !self::$rrdpng)
			self::$rrdpng = $me->rrd_pnglocation;
			
		elseif ($file)
			self::$rrdpng = $file;

		if (!self::$rrdfile)
			self::$rrdfile = $me->rrd_file;
			
		if ($timeframe >= 0)
			$timeframe = '-604800'; // default to 1 week
			 
			$graph_duration_title = duration_long($timeframe,0);
			
		$query = '/usr/bin/rrdtool graph '.self::$rrdpng.' '.
'--imgformat=PNG '.
'--start='.$timeframe.' '.
'--end=-300 '.
'--title="'.self::$title.' ['.$graph_duration_title."] (".strftime("%c", time()).')" '.
'--base=1000 '.
'--height=120 '.
'--width=600 '.
'--alt-autoscale '.
'--vertical-label="'.self::$vertical.'" '.
'--lower-limit=0 '.
'--slope-mode '.
'--font TITLE:12: '.
'--font AXIS:8: '.
'--font LEGEND:10: '.
'--font UNIT:8: '.
'--color BACK#0F3A6A50 '.
'--color CANVAS#CAFFFD '.
'--color FONT#A5A6A7 '.
'--rigid '.
'DEF:a="'.$me->rrd_file.'":ircusage:AVERAGE '.
'DEF:b="'.$me->rrd_file.'":ircusage:MAX '.
'DEF:c="'.$me->rrd_file.'":guests:AVERAGE '.
'DEF:d="'.$me->rrd_file.'":guests:MAX '.
'DEF:e="'.$me->rrd_file.'":guests:LAST '.
'DEF:f="'.$me->rrd_file.'":ircusage:LAST '.
'CDEF:registered=a,c,- '.
'AREA:a#0000FF:"Users"  '.
'TEXTALIGN:right '.
'GPRINT:a:LAST:"      Current\:%8.0lf"  '.
'GPRINT:a:AVERAGE:"Average\:%8.0lf"  '.
'GPRINT:a:MAX:"Max\:%8.0lf\n"  '.
'AREA:registered#070531:"Members" '.
'TEXTALIGN:right '.
'GPRINT:registered:LAST:"Current\:%8.0lf" '.
'GPRINT:registered:AVERAGE:"Average\:%8.0lf" '.
'GPRINT:registered:MAX:"Max\:%8.0lf \n" '.
'LINE2:c#16F32690:"Guests"  '.
'TEXTALIGN:right '.
'GPRINT:c:LAST:"    Current\:%8.0lf"  '.
'GPRINT:c:AVERAGE:"Average\:%8.0lf" '.
'GPRINT:c:MAX:"Max\:%8.0lf\n"';
		
		
		exec($query);
	}
}

?>