<?php
/**
 * BuddyServ IRC Services
 * 
 * Global unsorted commands
 * 
 * @name Commands
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Core
 * @version $Id: maincommands.php 330 2009-11-20 06:02:20Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

function duration_long($start, $end)
{
	return duration($start,$end,true);
}

function duration($s, $e, $long=false)
{  
    /* Find out the seconds between each dates */
    $timestamp = $e - $s;
    
    /* Cleaver Maths! */
    $years=floor($timestamp/(60*60*24*365));$timestamp%=60*60*24*365;
    $weeks=floor($timestamp/(60*60*24*7));$timestamp%=60*60*24*7;
    $days=floor($timestamp/(60*60*24));$timestamp%=60*60*24;
    $hrs=floor($timestamp/(60*60));$timestamp%=60*60;
    $mins=floor($timestamp/60);$secs=$timestamp%60;
   
    /* Display for date, can be modified more to take the S off */
    if ($years >= 1) 
    { 
    	$str .= sprintf("%d%s", 
    				$years,
    				($long === true ? ' years, ' : 'y ')); 
    }
    
    if ($weeks >= 1) 
    { 
    	$str .= sprintf("%d%s", 
    				$weeks,
    				($long === true ? ' weeks, ' : 'w ')); 
    }
    
    if ($days >= 1) 
    { 
    	$str .= sprintf("%d%s", 
    				$days,
    				($long === true ? ' days, ' : 'd ')); 
    }
    
    if ($hrs >= 1) 
    { 
    	$str .= sprintf("%d%s", 
    				$hrs,
    				($long === true ? ' hours, ' : 'h ')); 
    }
    
    if ($mins >= 1) 
    { 
    	$str .= sprintf("%d%s", 
    				$mins,
    				($long === true ? ' minutes, ' : 'm ')); 
    }
/*
    if ($weeks >= 1) { $str.= $weeks.'w'; }
    if ($days >= 1) { $str.=$days.'d'; }
    if ($hrs >= 1) { $str.=$hrs.' h'; }
    if ($mins >= 1) { $str.=$mins.'m'; } */
    
    if (!$str)
    	$str = sprintf("%d%s",
    		$timestamp,
    		($long === true ? ' seconds. ' : 's'));
   
     return $str;      
} 

/**
 * Makes the given mask a preg expression.
 * Used to convert *!*@* into php readable
 * wildcards.
 * 
 * @param string $mask
 * @return string
 */
function make_wild($mask)
{
	$wild = str_replace('?', '\S{1}', $mask);
	$wild = str_replace('*', '\S*', $wild);
	
	return $wild;
}

function convert_bytes($size)
{
	$sizetype = 0;
	
	while (1)
	{
		if (($size / 1024) > 1)
		{
			$sizetype++;
			$size = ($size / 1024);
				
				//	echo "size is now: {$size} with type {$sizetype}";
		}
				
		else 
			break;
		}

		$size = sprintf("%.2f", $size);
			
		if ($sizetype == 1)
			$byte = 'KB';
			
		elseif ($sizetype == 2)
			$byte = 'MB';
				
		elseif ($sizetype == 3)
			$byte = 'GiB';
				
		elseif ($sizetype == 4)
			$byte = 'TB';
			
		$array['size'] = $size;
		$array['byte'] = $byte;
		
		return $array;
}

function command_mymodes($arguments)
{
	global $irc, $response_codes, $me, $usermodes;
	
	array_shift($arguments);
	$nick = array_shift($arguments);
	$lcnick = strtolower($nick);
	$channel = array_shift($arguments);
	
	$user = user::getuser($nick);
	
	if (!$user)
	{
		$irc->send(sprintf(MSG, $me->nickserv['nick'], $channel, 'Normally, you would be ghosted as i dont have a record for you!'));
		return;
	}
	
	$currentmodes = '+';
	
	foreach ($usermodes as $mode => $binary)
	{
		if (($user->modes & $binary) > 0)
			$currentmodes .= $mode;
	}
	
	$irc->send(sprintf(MSG, $me->nickserv['nick'], $channel, 'You have modes: '. $currentmodes .' [binary: '. $user->modes .']'));
}


function command_idleall($arguments)
{
	global $irc, $response_codes;
	
	array_shift($arguments);
	$nick = array_shift($arguments);
	$lcnick = strtolower($nick);
	$channel = array_shift($arguments);
	
	$total_time = 0.00;
	$total_mb = 0.00;
	
	foreach (idle::$currents as $key => $array)
	{	
		$key_time = idle::get_time($key);
		
		if (!$key_time)
			continue;
		
		$key_time = ((time() - $key_time));
		
		$total_time += sprintf("%.2f", ($key_time / 60 / 60));
		$total_mb += sprintf("%.2f", ($key_time / 60 / 60) * 5);
	}
	
	$irc->send(sprintf(MSG, $channel, "Users this session have {$total_time}hrs [{$total_mb}mb] of idle bonus being recorded."));
}

	
function command_idlestats($arguments)
{
	global $irc, $response_codes;
	
	array_shift($arguments);
	$nick = array_shift($arguments);
	$channel = array_shift($arguments);

	$count = count(idle::$currents);
	$next_save = ((idle::$last_save + 7200) - time());
	$irc->send(sprintf(MSG, $channel, "Monitoring {$count} idlers, next update in {$next_save} seconds"));
	return true;
}

function command_saveidle($arguments)
{
	idle::check_dosave(false);
}

?>